<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\RelNotasNFCeInutilizadasService;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelNotasNFCeInutilizadas {
    
    protected $dataSourceName = 'orm00023_relNotasNFCeInutilizadas';
    protected $notasNFCeInutilizadas;
    protected $utilService;
    
    public function __construct (RelNotasNFCeInutilizadasService $notasNFCeInutilizadas, Utilities\Util $utilService ){
        $this->utilService = $utilService;
        $this->notasNFCeInutilizadas = $notasNFCeInutilizadas;
    }
    
    public function find(Request\Filter $request, Response $response) {
        
        try{
            $conditions = $this->utilService->getParamsAsArray($request);
            $result = [];
            if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])) {
                $response->addDataSet(new DataSet($this->dataSourceName, $this->notasNFCeInutilizadas->getNotas($conditions)));
                return $response;
            }
            return $result;
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}