<?php
namespace Teknisa\MAN\Services;  

use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use \Setforms2\Shared\ORM\DateTime;

class ParametrosIntegracao {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function saveParametrosIntegracao($array){
    	$nmparametro    = $array["NMPRAMETRO"];
		$valor          = $array["VALORPARAMETRO"];
		$nrorg          = $array["NRORG"];
		$cdoperador     = $array["CDOPERADOR"];
		$cdfilial       = $array["CDFILIAL"];
		$cdloja         = $array["CDLOJA"];
		$cdcaixa        = $array["CDCAIXA"];
		$cdtiporece     = $array["CDTIPORECE"];
		$valorparametro = explode('-', $valor);
		$params = array(
			'NRORGULTATU'=>$nrorg, 
			'CDOPERADOR' =>$cdoperador, 
			'CDTIPORECE'=>$cdtiporece,
			'VALOR'=>$valorparametro[0],
			'NRORG'=>$nrorg
		);
		$sql = 'UPDATE TIPORECE SET '.$nmparametro.'= :VALOR'.', DTULTATU = SYSDATE, NRORGULTATU = :NRORGULTATU, CDOPERULTATU = :CDOPERADOR WHERE NRORG = :NRORG AND CDTIPORECE = :CDTIPORECE';
		$this->entityManager->getConnection()->executeQuery($sql, $params);
	}

	public function getTiporeceFilial($params){
    	$param = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_TIPORECEFILIAL, $params);
    	return $param;
	}

	public function saveIntegracaoFilial($array){
		$nmparametro    = $array["NMPRAMETRO"];
		$valor          = $array["VALORPARAMETRO"];
		$nrorg          = $array["NRORG"];
		$cdoperador     = $array["CDOPERADOR"];
		$cdfilial       = $array["CDFILIAL"];
		$cdloja         = $array["CDLOJA"];
		$cdcaixa        = $array["CDCAIXA"];
		$cdtiporece     = $array["CDTIPORECE"];
		$vrtaxadmin     = 0;
		$valorparametro = explode('-', $valor);
		$nmparametro = self::trataStringParametro($nmparametro);
		$paramsTiporecefilial = array(
			'CDTIPORECE'=>$cdtiporece,
			'NRORG'=>$nrorg
		);
		$param = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_TIPORECEFILIAL_BYCDTIPORECE, $paramsTiporecefilial);
		if($param){
			$params = array(
				'NRORGULTATU'=>$nrorg, 
				'CDOPERADOR' =>$cdoperador, 
				'CDTIPORECE'=>$cdtiporece,
				'VALOR'=>$valorparametro[0],
				'NRORG'=>$nrorg
			);
			$sql = 'UPDATE TIPORECEFILIAL SET '.$nmparametro.'= :VALOR'.', DTULTATU = SYSDATE, NRORGULTATU = :NRORGULTATU, CDOPERULTATU = :CDOPERADOR WHERE NRORG = :NRORG AND CDTIPORECE = :CDTIPORECE';
		
			$this->entityManager->getConnection()->executeQuery($sql, $params);

		}else{
			$params = array(
				'NRORGINCLUSAO'=>$nrorg, 
				'CDOPERADOR' =>$cdoperador, 
				'CDTIPORECE'=>$cdtiporece,
				'VALOR'=>$valorparametro[0],
				'NRORG'=>$nrorg,
				'CDFILIAL'=>$cdfilial
			);
			if($nmparametro == 'VRTAXAADMFIL'){
				$sql = 'INSERT INTO TIPORECEFILIAL (CDFILIAL, CDTIPORECE,'.$nmparametro.', NRORGINCLUSAO, CDOPERINCLUSAO, DTINCLUSAO, NRORG)
            	VALUES(:CDFILIAL, :CDTIPORECE, :VALOR, :NRORGINCLUSAO, :CDOPERADOR, SYSDATE, :NRORG)';
			}else{
				$sql = 'INSERT INTO TIPORECEFILIAL (CDFILIAL, CDTIPORECE,'.$nmparametro.', NRORGINCLUSAO, CDOPERINCLUSAO, DTINCLUSAO, NRORG,VRTAXAADMFIL)
           		VALUES(:CDFILIAL, :CDTIPORECE, :VALOR, :NRORGINCLUSAO, :CDOPERADOR, SYSDATE, :NRORG, 0)';
			}
			$this->entityManager->getConnection()->executeQuery($sql, $params);
		}
	}

	public function trataStringParametro($string){
		if($string == 'VRTAXAADMI'){
			$nmparametro = 'VRTAXAADMFIL';
		}elseif($string == 'NRDIASADMI'){
			$nmparametro = 'NRDIASADMIFIL';
		}elseif($string == 'IDGERAFIN'){
			$nmparametro = 'IDGERAFINFIL';
		}else{
			return $string;
		}
		return $string;
	}

	
}