<?php
namespace Teknisa\MAN\Utilities;

class Resposta {

	private $message = '';
	private $error = false;
    private $result = [];
    private $status = 0;
    private $parameters = [];
    
    const NAO_INICIALIZADO = 0;
    const ERRO = 50;
    const SUCESSO = 70;
    const NAO_COMPLETADO = 25;
    
    public function getMessage() {
        return $this->message;
    }
    
    public function getResult() {
        return $this->result;
    }
    
    public function error() {
        return $this->error;
    }
    
    public function setError($error) {
        $this->error = $error;
    }
    
    public function setResult($result) {
        $this->result = $result;
    }
    
    public function setMessage($message) {
        $this->message = $message;
    }
    
    public function setStatus($numero) {
        $this->status = $numero;
    }
    
    public function getStatus() {
        return $this->status;
    }
    
    public function getLinhasResult() {
        if (!empty($this->result) && is_array($this->result)) {
            $linhas = sizeof($this->result);
        } else {
            $linhas = 0;
        }
        
        return $linhas;
    }
    
     public function setParameters($parameters) {
        $this->parameters = $parameters;
    }
    
    public function getParameters() {
        return $this->parameters;
    }
    
    public function toPrint() {
        $result = array(
            'message' => $this->getMessage(),
            'lines'   => $this->getLinhasResult(),
            'params'  => $this->getParameters(),
            'status'  => $this->getStatus(),
            'error'   => $this->error()
        );
        
        return $result;
    }
    
    
}